Time.new does not accept seconds as a String

03/23/2012 12:21 PM - john_firebaugh (John Firebaugh)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 1.9.3p125 (2012-02-16 revision

34643) [x86_64-darwin11.3.0]

Backport:  

Description

Time.new accepts any or all of the year, month, day, hour, or minute specified as a String, but does not accept a String value for

seconds:

Time.new("2012", "3", "22", "8", "19", 30)

=> 2012-03-22 08:19:30 -0700

Time.new("2012", "3", "22", "8", "19", "30")

TypeError: can't convert String into an exact number

from (irb):222:in initialize'  from (irb):222:in new'

from (irb):222

from /Users/john/.rvm/rubies/ruby-1.9.3-p125/bin/irb:16:in `'

 

Since all other arguments can be strings, and since Time.utc and Time.local accept String seconds, I believe the expected behavior

is that Time.new does as well.

Associated revisions

Revision 28e48d3fd8b7e9ae4d540a0111342a444a9ac061 - 03/24/2012 01:22 PM - nobu (Nobuyoshi Nakada)

time.c (time_init_1): Time.new will accept seconds as string or

int.  [ruby-core:43569][Bug #6193]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@35122 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 28e48d3f - 03/24/2012 01:22 PM - nobu (Nobuyoshi Nakada)

time.c (time_init_1): Time.new will accept seconds as string or

int.  [ruby-core:43569][Bug #6193]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@35122 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 03/23/2012 11:53 PM - ssuda (Sambasiva Suda)

- File ruby-time-sec-str.patch added

Here is the patch which will fix the problem with the seconds. There is also pull request for github.

#2 - 03/24/2012 01:20 AM - john_firebaugh (John Firebaugh)

I think you want to use the obj2subsecx helper, not obj2vint, so that fractional seconds are still supported.

#3 - 03/24/2012 06:48 AM - ssuda (Sambasiva Suda)

- File ruby-time-sec-str2.patch added

Here is the updated patch using obj2subsecx.

#4 - 03/24/2012 10:22 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed
- % Done changed from 0 to 100

This issue was solved with changeset r35122.

John, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

time.c (time_init_1): Time.new will accept seconds as string or

int.  [ruby-core:43569][Bug #6193]

Files

ruby-time-sec-str.patch 1.38 KB 03/23/2012 ssuda (Sambasiva Suda)

ruby-time-sec-str2.patch 1.57 KB 03/24/2012 ssuda (Sambasiva Suda)
